#pragma once

class XIndexBuffer : public IIndexBuffer
{
	DWORD						m_dwID;
	UINT						m_uiLength;
	DWORD						m_dwUsage;
	D3DFORMAT					m_dwFormat;
	D3DPOOL						m_dwPool;
	IDirect3DIndexBuffer8*		m_pIndexBuffer;
	IDirect3DDevice8*			m_lpDevice;
	// interface methods
	DWORD						m_dwRef;
public:
	virtual int						Create(UINT uiLength, DWORD dwUsage, D3DFORMAT dwFormat, D3DPOOL dwPool);
	virtual int						Restore();
	virtual int						ReleaseResource();
	virtual LPDIRECT3DINDEXBUFFER8	GetBuffer() { return m_pIndexBuffer; }
	virtual LPDIRECT3DDEVICE8		GetDevice() {return m_lpDevice; }
	virtual void					SetID(DWORD dwID) {m_dwID = dwID;}

	virtual HRESULT			AddRef();
	virtual HRESULT			Release();
public:
	XIndexBuffer(void);
	~XIndexBuffer(void);
};
